package org.vaadin.example;

import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.combobox.ComboBox;
import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.component.treegrid.TreeGrid;
import org.vaadin.example.bean.Department;
import org.vaadin.example.bean.DepartmentData;
import com.vaadin.flow.router.Route;

@Route(value = "")
public class FocusTreeGridView extends VerticalLayout {

    private DepartmentData departmentData = new DepartmentData();


    public FocusTreeGridView() {

        TreeGrid<Department> grid = buildGrid();
/*
        add(new Button("expand last item", e -> {
            grid.expand(departmentData.getRootDepartments().stream().filter(department -> department.getId() == 300).findFirst().get());
        }));*/
        add(new Button("scrolltoEnd", e -> grid.scrollToEnd()));

        addAndExpand(grid);
        setPadding(false);
        setSizeFull();
    }

    private TreeGrid<Department> buildGrid() {
        TreeGrid<Department> grid = new TreeGrid<>();
        grid.setItems(departmentData.getRootDepartments(),
            departmentData::getChildDepartments);
        grid.addHierarchyColumn(Department::getName).setHeader("Department Name").setKey("name");
        grid.setWidthFull();
        grid.expand(departmentData.getRootDepartments().stream().filter(department -> department.getId() == 300).findFirst().get());
        return grid;
    }
}
